3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2005 Junio C Hamano
11 USAGE
='[--edit | --no-edit] [-n] <commit-ish>' ;;
15 USAGE
='[--edit] [-n] [-r] <commit-ish>' ;;
17 die
"What are you talking about?" ;;
22 while case "$#" in 0) break ;; esac
25 -n|
--n|
--no|
--no-|
--no-c|
--no-co|
--no-com|
--no-comm|\
26 --no-commi|
--no-commit)
29 -e|
--e|
--ed|
--edi|
--edit)
32 --n|
--no|
--no-|
--no-e|
--no-ed|
--no-edi|
--no-edit)
35 -r|
--r|
--re|
--rep|
--repl|
--repla|
--replay)
48 test "$me,$replay" = "revert,t" && usage
52 # We do not intend to commit immediately. We just want to
53 # merge the differences in.
54 head=$
(git-write-tree
) ||
55 die
"Your index file is unmerged."
58 head=$
(git-rev-parse
--verify HEAD
) ||
59 die
"You do not have a valid HEAD"
60 files
=$
(git-diff-index
--cached --name-only $head) ||
exit
62 die
"Dirty index: cannot $me (dirty: $files)"
67 rev=$
(git-rev-parse
--verify "$@") &&
68 commit
=$
(git-rev-parse
--verify "$rev^0") ||
69 die
"Not a single commit $@"
70 prev
=$
(git-rev-parse
--verify "$commit^1" 2>/dev
/null
) ||
71 die
"Cannot run $me a root commit"
72 git-rev-parse
--verify "$commit^2" >/dev
/null
2>&1 &&
73 die
"Cannot run $me a multi-parent commit."
75 # "commit" is an existing commit. We would want to apply
76 # the difference it introduces since its first parent "prev"
77 # on top of the current HEAD if we are cherry-pick. Or the
78 # reverse of it if we are revert.
82 git-rev-list
--pretty=oneline
--max-count=1 $commit |
87 echo "This reverts $commit commit."
88 test "$rev" = "$commit" ||
89 echo "(original 'git revert' arguments: $@)"
90 base
=$commit next
=$prev
98 s/^author \([^<]*\) <[^>]*> .*$/\1/
100 s
/.
*/GIT_AUTHOR_NAME
='\''&'\''/p
103 s
/^author
[^
<]* <\
([^
>]*\
)> .
*$
/\
1/
105 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
108 s/^author [^<]* <[^>]*> \(.*\)$/\1/
110 s
/.
*/GIT_AUTHOR_DATE
='\''&'\''/p
114 set_author_env=`git-cat-file commit "$commit" |
115 LANG=C LC_ALL=C sed -ne "$pick_author_script"`
116 eval "$set_author_env"
117 export GIT_AUTHOR_NAME
118 export GIT_AUTHOR_EMAIL
119 export GIT_AUTHOR_DATE
121 git-cat-file commit $commit | sed -e '1,/^$
/d
'
124 echo "(cherry picked from $commit commit)"
125 test "$rev" = "$commit" ||
126 echo "(original 'git cherry-pick
' arguments: $@)"
129 base=$prev next=$commit
134 # This three way merge is an interesting one. We are at
135 # $head, and would want to apply the change between $commit
136 # and $prev on top of us (when reverting), or the change between
137 # $prev and $commit on top of us (when cherry-picking or replaying).
139 echo >&2 "First trying simple merge strategy to $me."
140 git-read-tree -m -u --aggressive $base $head $next &&
141 result=$(git-write-tree 2>/dev/null) || {
142 echo >&2 "Simple $me fails; trying Automatic $me."
143 git-merge-index -o git-merge-one-file -a || {
144 echo >&2 "Automatic $me failed. After resolving the conflicts,"
145 echo >&2 "mark the corrected paths with 'git-update-index
<paths
>'"
146 echo >&2 "and commit with 'git commit
-F .msg
'"
149 echo >&2 "You may choose to use the following when making"
150 echo >&2 "the commit:"
151 echo >&2 "$set_author_env"
155 result=$(git-write-tree) || exit
157 echo >&2 "Finished one $me."
159 # If we are cherry-pick, and if the merge did not result in
160 # hand-editing, we will hit this commit and inherit the original
161 # author date and name.
162 # If we are revert, or if our cherry-pick results in a hand merge,
163 # we had better say that the current user is responsible for that.
167 git-commit -n -F .msg $edit